searchData={"items":[{"type":"module","title":"TMI.ChannelServer","doc":"A GenServer for Channels that self-rate-limits joins.","ref":"TMI.ChannelServer.html"},{"type":"module","title":"Options - TMI.ChannelServer","doc":"- `:rate` (integer) - The rate at which to join channels. (one join per `rate`).\n    Optional. Defaults to `500` ms.","ref":"TMI.ChannelServer.html#module-options"},{"type":"module","title":"Twitch authentication and join rate limits: - TMI.ChannelServer","doc":"| Limit                         | Applies to\n    |-------------------------------|-------------------------\n    | 20 join attempts per 10       | Regular Twitch account\n    | seconds per user              |\n    |                               |\n    | 2000 join attempts per 10     | Verified bot\n    | seconds per user              |\n\nhttps://dev.twitch.tv/docs/irc/guide#rate-limits","ref":"TMI.ChannelServer.html#module-twitch-authentication-and-join-rate-limits"},{"type":"function","title":"TMI.ChannelServer.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"TMI.ChannelServer.html#child_spec/1"},{"type":"function","title":"TMI.ChannelServer.handle_call/3","doc":"Invoked to handle synchronous `call/3` messages. `call/3` will block until a\nreply is received (unless the call times out or nodes are disconnected).","ref":"TMI.ChannelServer.html#handle_call/3"},{"type":"function","title":"TMI.ChannelServer.handle_cast/2","doc":"Invoked to handle asynchronous `cast/2` messages.","ref":"TMI.ChannelServer.html#handle_cast/2"},{"type":"function","title":"TMI.ChannelServer.handle_info/2","doc":"Invoked to handle all other messages.\n\nFor example calling `Process.send_after(self(), :foo, 1000)` would send `:foo`\nafter one second, and we could match on that here.","ref":"TMI.ChannelServer.html#handle_info/2"},{"type":"function","title":"TMI.ChannelServer.init/1","doc":"Invoked when the server is started. `start_link/3` will block until it\nreturns.","ref":"TMI.ChannelServer.html#init/1"},{"type":"function","title":"TMI.ChannelServer.join/2","doc":"Add a channel to the JOIN queue.","ref":"TMI.ChannelServer.html#join/2"},{"type":"function","title":"TMI.ChannelServer.list_channels/1","doc":"List the channels that we have joined.","ref":"TMI.ChannelServer.html#list_channels/1"},{"type":"function","title":"TMI.ChannelServer.module_name/1","doc":"Get the bot-specific ChannelServer module name.","ref":"TMI.ChannelServer.html#module_name/1"},{"type":"function","title":"TMI.ChannelServer.part/2","doc":"PART from a channel.","ref":"TMI.ChannelServer.html#part/2"},{"type":"function","title":"TMI.ChannelServer.start_link/1","doc":"Start the channel server.","ref":"TMI.ChannelServer.html#start_link/1"},{"type":"function","title":"TMI.ChannelServer.update_mod_status/3","doc":"Update the moderator status of a mod for a channel.","ref":"TMI.ChannelServer.html#update_mod_status/3"},{"type":"module","title":"TMI.Client","doc":"TMI wrapper for ExIRC.Client.","ref":"TMI.Client.html"},{"type":"function","title":"TMI.Client.add_handler/2","doc":"Add a new event handler process.","ref":"TMI.Client.html#add_handler/2"},{"type":"function","title":"TMI.Client.add_handler_async/2","doc":"Add a new event handler process, asynchronously.","ref":"TMI.Client.html#add_handler_async/2"},{"type":"function","title":"TMI.Client.channel_has_user?/3","doc":"Determine if a user is present in the provided channel.","ref":"TMI.Client.html#channel_has_user?/3"},{"type":"function","title":"TMI.Client.channel_users/2","doc":"Get a list of users in the provided channel.","ref":"TMI.Client.html#channel_users/2"},{"type":"function","title":"TMI.Client.command/2","doc":"Send a raw IRC command to TMI IRC server.","ref":"TMI.Client.html#command/2"},{"type":"function","title":"TMI.Client.connect_ssl/1","doc":"Connect to a server with the provided server and port via SSL.","ref":"TMI.Client.html#connect_ssl/1"},{"type":"function","title":"TMI.Client.is_connected?/1","doc":"Determine if the provided client process has an open connection to a server.","ref":"TMI.Client.html#is_connected?/1"},{"type":"function","title":"TMI.Client.is_logged_on?/1","doc":"Determine if the provided client is logged on to a server.","ref":"TMI.Client.html#is_logged_on?/1"},{"type":"function","title":"TMI.Client.join/2","doc":"Join a channel.","ref":"TMI.Client.html#join/2"},{"type":"function","title":"TMI.Client.kick/4","doc":"Kick a user from a channel.","ref":"TMI.Client.html#kick/4"},{"type":"function","title":"TMI.Client.list_channels/1","doc":"Get a list of the channels the client has joined.","ref":"TMI.Client.html#list_channels/1"},{"type":"function","title":"TMI.Client.logon/1","doc":"Logon to a server.\n\nYour nickname (`nick`) must be your Twitch username (login name) in lowercase.\n\nA successful connection session looks like the following example:\n\n     \n     \n    > :tmi.twitch.tv 001   :Welcome, GLHF!\n    > :tmi.twitch.tv 002   :Your host is tmi.twitch.tv\n    > :tmi.twitch.tv 003   :This server is rather new\n    > :tmi.twitch.tv 004   :-\n    > :tmi.twitch.tv 375   :-\n    > :tmi.twitch.tv 372   :You are in a maze of twisty passages.\n    > :tmi.twitch.tv 376   :>","ref":"TMI.Client.html#logon/1"},{"type":"function","title":"TMI.Client.me/3","doc":"Send an action message, i.e. (/me slaps someone with a big trout)","ref":"TMI.Client.html#me/3"},{"type":"function","title":"TMI.Client.normalize_channel/1","doc":"Map channel names to channel names with the prepended \"#\".","ref":"TMI.Client.html#normalize_channel/1"},{"type":"function","title":"Examples - TMI.Client.normalize_channel/1","doc":"iex> TMI.Client.normalize_channel(\"#foo\")\n    \"#foo\"\n\n    iex> TMI.Client.normalize_channel(\"bar\")\n    \"#bar\"","ref":"TMI.Client.html#normalize_channel/1-examples"},{"type":"function","title":"TMI.Client.part/2","doc":"Leave a channel.","ref":"TMI.Client.html#part/2"},{"type":"function","title":"TMI.Client.quit/2","doc":"Quit the server.","ref":"TMI.Client.html#quit/2"},{"type":"function","title":"TMI.Client.remove_handler/2","doc":"Remove an event handler process.","ref":"TMI.Client.html#remove_handler/2"},{"type":"function","title":"TMI.Client.remove_handler_async/2","doc":"Remove an event handler process, asynchronously","ref":"TMI.Client.html#remove_handler_async/2"},{"type":"function","title":"TMI.Client.say/3","doc":"Send a channel message.","ref":"TMI.Client.html#say/3"},{"type":"function","title":"TMI.Client.start_link/1","doc":"","ref":"TMI.Client.html#start_link/1"},{"type":"function","title":"TMI.Client.stop/1","doc":"Stop the client process.","ref":"TMI.Client.html#stop/1"},{"type":"function","title":"TMI.Client.whisper/3","doc":"Send a whisper message to a user.","ref":"TMI.Client.html#whisper/3"},{"type":"module","title":"TMI.ConnectionServer","doc":"Handles connections to Twitch chat.","ref":"TMI.ConnectionServer.html"},{"type":"function","title":"TMI.ConnectionServer.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"TMI.ConnectionServer.html#child_spec/1"},{"type":"function","title":"TMI.ConnectionServer.handle_continue/2","doc":"Invoked to handle `continue` instructions.\n\nIt is useful for performing work after initialization or for splitting the\nwork in a callback in multiple steps, updating the process state along the\nway.","ref":"TMI.ConnectionServer.html#handle_continue/2"},{"type":"function","title":"TMI.ConnectionServer.handle_info/2","doc":"Invoked to handle all other messages.\n\nFor example calling `Process.send_after(self(), :foo, 1000)` would send `:foo`\nafter one second, and we could match on that here.","ref":"TMI.ConnectionServer.html#handle_info/2"},{"type":"function","title":"TMI.ConnectionServer.init/1","doc":"Invoked when the server is started. `start_link/3` will block until it\nreturns.","ref":"TMI.ConnectionServer.html#init/1"},{"type":"function","title":"TMI.ConnectionServer.module_name/1","doc":"Get the bot-specific module name.","ref":"TMI.ConnectionServer.html#module_name/1"},{"type":"function","title":"TMI.ConnectionServer.start_link/1","doc":"Start the connection handler.","ref":"TMI.ConnectionServer.html#start_link/1"},{"type":"behaviour","title":"TMI.Handler","doc":"Handler behaviour for TMI.","ref":"TMI.Handler.html"},{"type":"callback","title":"TMI.Handler.handle_action/3","doc":"","ref":"TMI.Handler.html#c:handle_action/3"},{"type":"callback","title":"TMI.Handler.handle_action/4","doc":"","ref":"TMI.Handler.html#c:handle_action/4"},{"type":"callback","title":"TMI.Handler.handle_connected/2","doc":"","ref":"TMI.Handler.html#c:handle_connected/2"},{"type":"callback","title":"TMI.Handler.handle_disconnected/0","doc":"","ref":"TMI.Handler.html#c:handle_disconnected/0"},{"type":"callback","title":"TMI.Handler.handle_join/1","doc":"","ref":"TMI.Handler.html#c:handle_join/1"},{"type":"callback","title":"TMI.Handler.handle_join/2","doc":"","ref":"TMI.Handler.html#c:handle_join/2"},{"type":"callback","title":"TMI.Handler.handle_kick/2","doc":"","ref":"TMI.Handler.html#c:handle_kick/2"},{"type":"callback","title":"TMI.Handler.handle_kick/3","doc":"","ref":"TMI.Handler.html#c:handle_kick/3"},{"type":"callback","title":"TMI.Handler.handle_logged_in/0","doc":"","ref":"TMI.Handler.html#c:handle_logged_in/0"},{"type":"callback","title":"TMI.Handler.handle_login_failed/1","doc":"","ref":"TMI.Handler.html#c:handle_login_failed/1"},{"type":"callback","title":"TMI.Handler.handle_mention/3","doc":"","ref":"TMI.Handler.html#c:handle_mention/3"},{"type":"callback","title":"TMI.Handler.handle_message/3","doc":"","ref":"TMI.Handler.html#c:handle_message/3"},{"type":"callback","title":"TMI.Handler.handle_message/4","doc":"","ref":"TMI.Handler.html#c:handle_message/4"},{"type":"callback","title":"TMI.Handler.handle_part/1","doc":"","ref":"TMI.Handler.html#c:handle_part/1"},{"type":"callback","title":"TMI.Handler.handle_part/2","doc":"","ref":"TMI.Handler.html#c:handle_part/2"},{"type":"callback","title":"TMI.Handler.handle_unrecognized/1","doc":"","ref":"TMI.Handler.html#c:handle_unrecognized/1"},{"type":"callback","title":"TMI.Handler.handle_unrecognized/2","doc":"","ref":"TMI.Handler.html#c:handle_unrecognized/2"},{"type":"callback","title":"TMI.Handler.handle_whisper/2","doc":"","ref":"TMI.Handler.html#c:handle_whisper/2"},{"type":"callback","title":"TMI.Handler.handle_whisper/3","doc":"","ref":"TMI.Handler.html#c:handle_whisper/3"},{"type":"module","title":"TMI.MessageServer","doc":"A GenServer for Sending messages at a specified rate to a single channel.","ref":"TMI.MessageServer.html"},{"type":"module","title":"Options - TMI.MessageServer","doc":"- `:rate` (integer) - The rate at which to send the messages. (one message\n    per `rate`). Optional. Defaults to `1500` ms.","ref":"TMI.MessageServer.html#module-options"},{"type":"module","title":"Twitch command and message rate limits: - TMI.MessageServer","doc":"If command and message rate limits are exceeded, an application cannot send channel\nmessages or commands for 30 minutes.\n\n    | Limit                         | Applies to\n    |-------------------------------|---------------------------------------------\n    | 20 per 30 seconds             | Users sending commands or messages to\n    |                               | channels in which they are not the broadcaster\n    |                               | and do not have Moderator status.\n    |                               |\n    | 100 per 30 seconds            | Users sending commands or messages to channels\n    |                               | in which they are the broadcaster or have\n    |                               | Moderator status.\n    |                               |\n    | 7500 per 30 seconds           | Verified bots. The channel limits above also\n    | site-wide                     | apply. In other words, one of the two limits\n    |                               | above will also be applied depending on\n    |                               | whether the verified bot is the broadcaster\n    |                               | or has Moderator status.\n\nhttps://dev.twitch.tv/docs/irc/guide#rate-limits","ref":"TMI.MessageServer.html#module-twitch-command-and-message-rate-limits"},{"type":"function","title":"TMI.MessageServer.add_command/2","doc":"Add a command to the outbound message queue.","ref":"TMI.MessageServer.html#add_command/2"},{"type":"function","title":"TMI.MessageServer.add_command/3","doc":"Add a command to the outbound message queue.","ref":"TMI.MessageServer.html#add_command/3"},{"type":"function","title":"TMI.MessageServer.add_message/2","doc":"Add a message to the outbound message queue.","ref":"TMI.MessageServer.html#add_message/2"},{"type":"function","title":"TMI.MessageServer.add_message/3","doc":"Add a message to the outbound message queue.","ref":"TMI.MessageServer.html#add_message/3"},{"type":"function","title":"TMI.MessageServer.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"TMI.MessageServer.html#child_spec/1"},{"type":"function","title":"TMI.MessageServer.handle_cast/2","doc":"Invoked to handle asynchronous `cast/2` messages.","ref":"TMI.MessageServer.html#handle_cast/2"},{"type":"function","title":"TMI.MessageServer.handle_info/2","doc":"Invoked to handle all other messages.\n\nFor example calling `Process.send_after(self(), :foo, 1000)` would send `:foo`\nafter one second, and we could match on that here.","ref":"TMI.MessageServer.html#handle_info/2"},{"type":"function","title":"TMI.MessageServer.init/1","doc":"Invoked when the server is started. `start_link/3` will block until it\nreturns.","ref":"TMI.MessageServer.html#init/1"},{"type":"function","title":"TMI.MessageServer.module_name/2","doc":"Generate the bot and channel specific module name.","ref":"TMI.MessageServer.html#module_name/2"},{"type":"function","title":"TMI.MessageServer.start_link/1","doc":"Start the message server. Usually because of a `JOIN`.","ref":"TMI.MessageServer.html#start_link/1"},{"type":"function","title":"TMI.MessageServer.stop/1","doc":"Stop the message server. Usually because of a `PART`.","ref":"TMI.MessageServer.html#stop/1"},{"type":"function","title":"TMI.MessageServer.stop/2","doc":"Stop the message server. Usually because of a `PART`.","ref":"TMI.MessageServer.html#stop/2"},{"type":"function","title":"TMI.MessageServer.supervisor_name/1","doc":"Generate the bot and channel specific module name.","ref":"TMI.MessageServer.html#supervisor_name/1"},{"type":"function","title":"TMI.MessageServer.update_mod_status/2","doc":"Update the mod status of the bot for the channel.","ref":"TMI.MessageServer.html#update_mod_status/2"},{"type":"module","title":"TMI.Supervisor","doc":"TMI is a library for connecting to Twitch chat with Elixir.","ref":"TMI.Supervisor.html"},{"type":"function","title":"TMI.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"TMI.Supervisor.html#child_spec/1"},{"type":"function","title":"TMI.Supervisor.start_link/1","doc":"Start the TMI supervisor.","ref":"TMI.Supervisor.html#start_link/1"},{"type":"module","title":"TMI.WhisperServer","doc":"A GenServer for Sending whispers at a specified rate.","ref":"TMI.WhisperServer.html"},{"type":"module","title":"Twitch whispers rate limits: - TMI.WhisperServer","doc":"If the Whisper rate limits are exceeded, an application cannot send Whispers\nfor 24 hours.\n\n    | Limit                               | Applies to\n    |-------------------------------------|-----------------------\n    | 3 per second, up to 100 per minute, | All Twitch accounts\n    | for 40 accounts per day             |\n\nhttps://dev.twitch.tv/docs/irc/guide#rate-limits","ref":"TMI.WhisperServer.html#module-twitch-whispers-rate-limits"},{"type":"function","title":"TMI.WhisperServer.add_whisper/4","doc":"Add a whisper to the outbound message queue.","ref":"TMI.WhisperServer.html#add_whisper/4"},{"type":"function","title":"TMI.WhisperServer.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"TMI.WhisperServer.html#child_spec/1"},{"type":"function","title":"TMI.WhisperServer.handle_cast/2","doc":"Invoked to handle asynchronous `cast/2` messages.","ref":"TMI.WhisperServer.html#handle_cast/2"},{"type":"function","title":"TMI.WhisperServer.handle_info/2","doc":"Invoked to handle all other messages.\n\nFor example calling `Process.send_after(self(), :foo, 1000)` would send `:foo`\nafter one second, and we could match on that here.","ref":"TMI.WhisperServer.html#handle_info/2"},{"type":"function","title":"TMI.WhisperServer.init/1","doc":"Invoked when the server is started. `start_link/3` will block until it\nreturns.","ref":"TMI.WhisperServer.html#init/1"},{"type":"function","title":"TMI.WhisperServer.module_name/1","doc":"Generate the bot specific module name.","ref":"TMI.WhisperServer.html#module_name/1"},{"type":"function","title":"TMI.WhisperServer.start_link/1","doc":"Start the message server. Usually because of a `JOIN`.","ref":"TMI.WhisperServer.html#start_link/1"},{"type":"function","title":"TMI.WhisperServer.stop/1","doc":"Stop the message server. Usually because of a `PART`.","ref":"TMI.WhisperServer.html#stop/1"},{"type":"extras","title":"TMI (Twitch Messaging Interface) for Elixir","doc":"# TMI (Twitch Messaging Interface) for Elixir\n\n[![Hex.pm](https://img.shields.io/hexpm/v/tmi)](https://hex.pm/packages/tmi)\n[![Hex.pm](https://img.shields.io/hexpm/dt/tmi)](https://hex.pm/packages/tmi)\n[![Hex.pm](https://img.shields.io/hexpm/l/tmi)](https://github.com/ryanwinchester/tmi.ex/blob/main/LICENSE)\n\nConnect to Twitch chat with Elixir.","ref":"readme.html"},{"type":"extras","title":"Installation - TMI (Twitch Messaging Interface) for Elixir","doc":"The package can be installed by adding `tmi` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:tmi, \"~> 0.7.0\"},\n  ]\nend\n```\n\nDocumentation can be found at [https://hexdocs.pm/tmi/readme.html](https://hexdocs.pm/tmi/readme.html).","ref":"readme.html#installation"},{"type":"extras","title":"Usage - TMI (Twitch Messaging Interface) for Elixir","doc":"You can use your own Twitch username, but it is recommended to make a new twitch account just for your bot.\nYou'll also need an OAuth token for the password.\n\nThe simplest method to get an OAuth token (while logged in to the account your bot will use), use the [Twitch Chat OAuth Password Generator](https://twitchapps.com/tmi/).\n\nCreate a bot module to deal with chat messages or events:\n\n```elixir\ndefmodule MyBot do\n  use TMI\n\n  @impl TMI.Handler\n  def handle_message(\"!\" <> command, sender, chat) do\n    case command do\n      \"dice\" ->\n        say(chat, Enum.random(~w(⚀ ⚁ ⚂ ⚃ ⚄ ⚅)))\n\n      \"echo \" <> rest ->\n        say(chat, rest)\n\n      \"dance\" ->\n        me(chat, \"dances for #{sender}\")\n\n      _ ->\n        say(chat, \"unrecognized command\")\n    end\n  end\n\n  def handle_message(message, sender, chat) do\n    Logger.debug(\"Message in #{chat} from #{sender}: #{message}\")\n  end\nend\n```\n\n#### Available handler callbacks:\n\n    handle_connected(server, port)\n    handle_logged_in()\n    handle_login_failed(reason)\n    handle_disconnected()\n    handle_join(chat)\n    handle_join(chat, user)\n    handle_part(chat)\n    handle_part(chat, user)\n    handle_kick(chat, kicker)\n    handle_kick(chat, user, kicker)\n    handle_whisper(message, sender)\n    handle_whisper(message, sender, tags)\n    handle_message(message, sender, chat)\n    handle_message(message, sender, chat, tags)\n    handle_mention(message, sender, chat)\n    handle_action(message, sender, chat)\n    handle_unrecognized(msg)\n    handle_unrecognized(msg, tags)","ref":"readme.html#usage"},{"type":"extras","title":"Starting - TMI (Twitch Messaging Interface) for Elixir","doc":"First we need to go over the config options.\n\n#### Config options\n\n- `:bot` - The module that `use`s `TMI` and implements the `TMI.Handler` behaviour.\n- `:user` - Twitch username of your bot user (lowercase).\n- `:pass` - OAuth token to use as a password, prefixed with `oauth:`.\n- `:channels` - The list of channels to join (lowercase).\n- `:mod_channels` - The list of channels where your bot is a moderator\n  (this effects the message and command rate limits).\n\n#### Example config\n\n```elixir\nconfig :my_app,\n  bots: [\n    [\n      bot: MyApp.Bot,\n      user: \"myappbot\",\n      pass: \"oauth:myappbotpassword\",\n      channels: [\"mychannel\", \"foo\"],\n      mod_channels: [\"mychannel\"],\n      debug: false\n    ]\n  ]\n```","ref":"readme.html#starting"},{"type":"extras","title":"Add to your supervision tree - TMI (Twitch Messaging Interface) for Elixir","doc":"##### Single bot example:\n\n```elixir\n[bot_config] = Application.fetch_env!(:my_app, :bots)\n\nchildren = [\n  # If you have existing children, e.g.:\n  Existing.Worker,\n  {Another.Existing.Supervisor, []},\n  # Add the bot.\n  {TMI.Supervisor, bot_config}\n]\n\nSupervisor.start_link(children, strategy: :one_for_one, name: MyApp.Supervisor)\n```\n\n##### Multiple bots example:\n\n```elixir\nbots = Application.fetch_env!(:my_app, :bots)\nbot_children = for bot_config <- bots, do: {TMI.Supervisor, bot_config}\n\nchildren = [\n  # If you have existing children, e.g.:\n  Existing.Worker,\n  {Another.Existing.Supervisor, []}\n  # Add the bot children.\n  | bot_children\n]\n\nSupervisor.start_link(children, strategy: :one_for_one, name: MyApp.Supervisor)\n```","ref":"readme.html#add-to-your-supervision-tree"},{"type":"extras","title":"To get your bot verified: - TMI (Twitch Messaging Interface) for Elixir","doc":"Visit https://dev.twitch.tv/limit-increase/ and have a good reason prepared.","ref":"readme.html#to-get-your-bot-verified"},{"type":"extras","title":"Copyright and License - TMI (Twitch Messaging Interface) for Elixir","doc":"Copyright 2020 Ryan Winchester\n\nLicensed under the Apache License, Version 2.0 (the \"License\");\nyou may not use this file except in compliance with the License.\nYou may obtain a copy of the License at\n\n    http://www.apache.org/licenses/LICENSE-2.0\n\nUnless required by applicable law or agreed to in writing, software\ndistributed under the License is distributed on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\nSee the License for the specific language governing permissions and\nlimitations under the License.","ref":"readme.html#copyright-and-license"},{"type":"extras","title":"For the memes - TMI (Twitch Messaging Interface) for Elixir","doc":"![roxcar76](https://user-images.githubusercontent.com/2897340/163022131-e86af85b-6b2f-4ee8-b44b-486f267ac7bd.png)","ref":"readme.html#for-the-memes"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,50,46,49]}}